/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// BrowserServiceAsync.java
// Since: Apr 20, 2007
//
// $URL: http://svn.utgenome.org/utgb/tags/utgb/utgb-core/utgb-core-1.0.3/src/main/java/org/utgenome/gwt/utgb/client/BrowserServiceAsync.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.client;

import java.util.List;

import org.utgenome.gwt.utgb.client.bean.track.TrackDescription;
import org.utgenome.gwt.utgb.client.bio.AlignmentResult;
import org.utgenome.gwt.utgb.client.bio.Gene;
import org.utgenome.gwt.utgb.client.track.bean.SearchResult;
import org.utgenome.gwt.utgb.client.track.bean.TrackBean;

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.RemoteService;

public interface BrowserServiceAsync extends RemoteService
{

    public void getHTTPContent(String url, AsyncCallback<String> callback);

    public void getTrackDescription(String url, AsyncCallback<TrackDescription> callback);

    public void getDatabaseCatalog(String jdbcAddress, AsyncCallback<String> callback);

    public void getTableData(String jdbcAddress, String tableName, AsyncCallback<String> callback);

    public void getTrackList(int entriesPerPage, int page, AsyncCallback<List<TrackBean>> callback);

    public void numHitsOfTracks(String prefix, AsyncCallback<Integer> callback);

    public void getTrackList(String prefix, int entriesPerPage, int page, AsyncCallback<List<TrackBean>> callback);

    public void keywordSearch(String species, String revision, String keyword, int entriesPerPage, int page,
            AsyncCallback<SearchResult> callback);

    public void getGeneList(String serviceURI, AsyncCallback<List<Gene>> asyncCallback);

    public void getAlignment(String serviceURI, String target, String sequence, AsyncCallback<AlignmentResult> callback);

}
