/*--------------------------------------------------------------------------
 *  Copyright 2007 Taro L. Saito
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// XerialJ
//
// BeanException.java
// Since: Dec 18, 2007 12:47:54 PM
//
// $URL: https://www.xerial.org/svn/project/XerialJ/tags/xerial-core/xerial-core-1.0.12/src/main/java/org/xerial/util/bean/BeanException.java $
// $Author: leo $
//--------------------------------------
package org.xerial.util.bean;

import org.xerial.core.XerialException;

/**
 * Bean related exception
 * 
 * @author leo
 * 
 */
public class BeanException extends XerialException
{
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    /**
     * @param errorCode
     * @param message
     * @param e
     */
    public BeanException(BeanErrorCode errorCode, String message, Throwable e)
    {
        super(errorCode, message, e);
    }

    /**
     * @param errorCode
     * @param message
     */
    public BeanException(BeanErrorCode errorCode, String message)
    {
        super(errorCode, message);
    }

    /**
     * @param errorCode
     * @param e
     */
    public BeanException(BeanErrorCode errorCode, Throwable e)
    {
        super(errorCode, e);
    }

    public BeanException(BeanErrorCode errorCode)
    {
        super(errorCode);
    }

    public BeanErrorCode getErrorCode()
    {
        return (BeanErrorCode) super.getErrorCode();
    }
}
